/**
 * 
 */
var ParenthesisCounter=0;

function addListener(elementID){
	document.getElementById(elementID).addEventListener("input", function() {
		if(badUserInput(elementID)){
			$("#"+elementID).mouseenter(function() {
			    $("#"+elementID).css("color","#FFFFFF").css("background","#000000");
			}).mouseleave(function() {
				$("#"+elementID).css("color","#FFFFFF").css("background","#000000");
			});
			$("#"+elementID).css("color", "#FFFFFF").css("background", "#000000");
		}
		else{
			$("#"+elementID).mouseenter(function() {
			    $("#"+elementID).css("color","#FF0000").css("background","#FFFF00");
			}).mouseleave(function() {
				$("#"+elementID).css("color","#0000FF").css("background","#FFFFFF");
			});
			$("#"+elementID).css("color","#0000FF").css("background","#FFFFFF");
		}
	}, false);
}

function badUserInput(elementID){
    var dataOK=true;
    var permittedVarNames="xy";
    if(currentPage==pgSortedShow)permittedVarNames="ji";
	switch(elementID){
    case "var1":
    	dataOK=varNameOK(document.getElementById(elementID).innerHTML,varNameRestricted,permittedVarNames);
    	varOK[0]=dataOK;
    	break;
    case "startVal1":
    	dataOK=arithmeticValueOK(document.getElementById(elementID).innerHTML);
    	startValOK[0]=dataOK;
    	break;
    case "endVal1":
    	dataOK=arithmeticValueOK(document.getElementById(elementID).innerHTML);
    	endValOK[0]=dataOK;
    	break;
    case "stepVal1":
    	dataOK=arithmeticValueOK(document.getElementById(elementID).innerHTML);
    	stepValOK[0]=dataOK;
    	break;
    case "coord1":
    	var varName1=document.getElementById("var1").innerHTML;
    	var varName2=document.getElementById("var2").innerHTML;
    	dataOK=coordOK(varName1,varName2,elementID);
    	expressionOK[0]=dataOK;
    	break;
    case "var2":
    	dataOK=varNameOK(document.getElementById(elementID).innerHTML,varNameRestricted,permittedVarNames);
    	varOK[1]=dataOK;
    	break;
    case "startVal2":
    	var varName1=document.getElementById("var1").innerHTML;
    	var varName2=document.getElementById("var2").innerHTML;
    	dataOK=coordOK(varName1,varName2,elementID);

    	
    	//dataOK=arithmeticValueOK(document.getElementById(elementID).innerHTML);
    	startValOK[1]=dataOK;
    	break;
    case "endVal2":
    	var varName1=document.getElementById("var1").innerHTML;
    	var varName2=document.getElementById("var2").innerHTML;
    	dataOK=coordOK(varName1,varName2,elementID);

    	//dataOK=arithmeticValueOK(document.getElementById(elementID).innerHTML);
    	endValOK[1]=dataOK;
    	break;
    case "stepVal2":
    	dataOK=arithmeticValueOK(document.getElementById(elementID).innerHTML);
    	stepValOK[1]=dataOK;
    	break;
    case "coord2":
    	var varName1=document.getElementById("var1").innerHTML;
    	var varName2=document.getElementById("var2").innerHTML;
    	dataOK=coordOK(varName1,varName2,elementID);
    	expressionOK[1]=dataOK;
    	break;
    case "selectedRow":
    	dataOK=arithmeticValueOK(document.getElementById(elementID).innerHTML);
    	selectedRowOK=dataOK;
    	break;
    case "selectedColumn":
    	dataOK=arithmeticValueOK(document.getElementById(elementID).innerHTML);
    	selectedColumnOK=dataOK;
    	break;
    }
	setErrorMessage();
	return !dataOK;
}

function setErrorMessage(){
	var errorMessage="";
	if (!(selectedRowOK && selectedColumnOK)) errorMessage+="Μη αποδεκτή τιμή μεταβλητής";
	if (!varOK[0]) errorMessage+="Μη αποδεκτό όνομα μεταβλητής1";
	if (!startValOK[0]) errorMessage+="<br>Μη αποδεκτή αρχική τιμή1";
	if (!endValOK[0]) errorMessage+="<br>Μη αποδεκτή τελική τιμή1";
	if (!stepValOK[0]) errorMessage+="<br>Μη αποδεκτή τιμή βήματος1";
	if (!varOK[1]) errorMessage+="<br>Μη αποδεκτό όνομα μεταβλητής2";
	if (!startValOK[1]) errorMessage+="<br>Μη αποδεκτή αρχική τιμή2";
	if (!endValOK[1]) errorMessage+="<br>Μη αποδεκτή τελική τιμή2";
	if (!stepValOK[1]) errorMessage+="<br>Μη αποδεκτή τιμή βήματος2";
	if (!expressionOK[0]){
		errorMessage+="<br>Μη αποδεκτή αλγεβρική έκφραση1";
	}
	/*else{
		var varName1=document.getElementById("var1").innerHTML;
		var varName2=document.getElementById("var2").innerHTML;
		errorMessage+=UserFunctionOutput(varName1,varName2,document.getElementById("coord1").innerHTML,5,1);
	}*/
	if (!expressionOK[1]) errorMessage+="<br>Μη αποδεκτή αλγεβρική έκφραση2";
	showErrorMessage(errorMessage);
}

function showErrorMessage(errorMessage){
	document.getElementById("errorMessage").innerHTML=errorMessage;
	if(errorMessage!=""){
		$("#errorMessage").css("padding","4px");
		$("#runTool").hide(jQueryAnimationRate);
	}
	else{
		$("#errorMessage").css("padding","0px");
		if (!programRunning) $("#runTool").show(jQueryAnimationRate);
	}
}

function varNameOK(varName,nameRestrictionMode,allowedVarNames){
	var name=varName.toLowerCase();
	var charOK=true;
	if(nameRestrictionMode==varNameRestricted){//Περιορισμός επιτρεπτών ονομάτων (μήκος ενός χαρακτήρα)
		if(allowedVarNames.indexOf(name)==-1 || name.length!=1){
			charOK=false;
		}
		else{
			charOK=true;
		}
	}
	else{//Ονόματα οριζόμενα από το χρήστη
		var i=0,char=0;
		charOK=name.length>0?true:false;
		while (charOK && i<name.length){
			char=name.charAt(i);
			charOK=((char>="a" && char<="z") || (i>0 && char>="0" && char<="9") || char=="_");
			i++;
		}
	}
	return charOK;
}

function arithmeticValueOK(value){
	var i=0,char=0;
	var digitOK=value.length>0?true:false;
	while (digitOK && i<value.length){
		char=value.charAt(i);
		digitOK=char>="0" && char<="9" || (char=="+" || char=="-") && i==0;
		i++;
	}
	return digitOK;
}

function coordOK2(value){
	var i=0,char=0;
	var digitOK=value.length>0?true:false;
	while (digitOK && i<value.length){
		char=value.charAt(i);
		digitOK=char>="0" && char<="9";
		i++;
	}
	return digitOK;
}

function coordOK(varName1,varName2,elementID){
	var DataOk=true;
	var value=document.getElementById(elementID).innerHTML.toLowerCase();
	var i,Length=value.length;
	var CurrentChar="";
	var SearchResult;
	//var AuxExpr;
	var addOperators="+-";
	var multOperators="*/";
	var functionsLastChar="nset"; //siN/taN/ln, coS/abS, E, sqrT //λείπει η 'Ακέραιο Μέρος' 
	ParenthesisCounter=0;

	
	//1. Έλεγχος ορθότητας/πληρότητας παρενθέσεων
	i=0;
	while(i<Length && DataOk){
		CurrentChar=value.charAt(i);
		if(CurrentChar=="("){ //Αν ανοίγει παρένθεση...
			ParenthesisCounter++; //...αύξησε το μετρητή
			if(i==1){ //Αν βρίσκεται στη δεύτερη θέση του string...
				var prevChar=value.charAt(i-1);
				//...έλεγξε αν πριν την παρένθεση υπάρχει προσθετικό σύμβολο πράξης ή άλλη παρένθεση
				if(addOperators.indexOf(prevChar)==-1 && prevChar!="("){
					DataOk=false;
				}
			}
			else if (i>1){ //Αν βρίσκεται μετά τη δεύτερη θέση του string...
				var prevChar=value.charAt(i-1);
				//...έλεγξε αν πριν την παρένθεση υπάρχει οποιοδήποτε σύμβολο πράξης, άλλη παρένθεση, ή συνάρτηση
				if(addOperators.indexOf(prevChar)==-1 && multOperators.indexOf(prevChar)==-1 && prevChar!="(" &&  functionsLastChar.indexOf(prevChar)==-1){
					DataOk=false;
				}
			}
			if(value.charAt(i+1)==")") DataOk=false; //Αν η παρένθεση κλείνει χωρίς περιεχόμενο, σηματοδότησε σφάλμα 
		}
		if(CurrentChar==")"){ //Αν κλείνει παρένθεση...
			ParenthesisCounter--; //...μείωσε το μετρητή
			if(i<Length-1){ //Αν δε βρίσκεσαι στην τελευταία θέση του string ...
				//...έλεγξε αν μετά την παρένθεση υπάρχει σύμβολο πράξης ή άλλη παρένθεση που κλείνει
				var nextChar=value.charAt(i+1);
				if(addOperators.indexOf(nextChar)==-1 && multOperators.indexOf(nextChar)==-1 && nextChar!=")") DataOk=false;
			}
			if(i>0){ //Αν δε βρίσκεσαι στην πρώτη θέση του string ...
				//...έλεγξε αν πριν την παρένθεση υπάρχει σύμβολο πράξης
				var prevChar=value.charAt(i-1);
				if(addOperators.indexOf(prevChar)!=-1 || multOperators.indexOf(prevChar)!=-1) DataOk=false;
			}
			//Αν κλείνει παρένθεση χωρίς να έχει ανοίξει σηματοδότησε σφάλμα (καλύπτει και την περίπτωση έναρξης του string με ')'
			if(ParenthesisCounter<0) DataOk=false;
		}
		i++;
	}
	if(ParenthesisCounter!=0) DataOk=false;
	if (!DataOk) return DataOk; //Αν έχει ήδη βρεθεί σφάλμα, τερμάτισε τον έλεγχο

	//2. Έλεγχος αρχικού συμβόλου πράξης
	CurrentChar=value.charAt(0);
	if(CurrentChar=="*" || CurrentChar=="/"){
		DataOk=false;
	}

	//3. Έλεγχος τελικού συμβόλου πράξης
	CurrentChar=value.charAt(Length-1);
	if(CurrentChar=="+" || CurrentChar=="-" || CurrentChar=="*" || CurrentChar=="/"){
		DataOk=false;
	}

	//4. Απλοποίηση επιτρεπτών συνδυασμών (μόνο αν δεν έχει εμφανιστεί ήδη λάθος)
	if(DataOk){
		var simplifying=true;
		while(simplifying){
			simplifying=false;
			while(value.indexOf("++")!=-1){
				SearchResult=value.indexOf("++");
				value=value.substring(0,SearchResult)+value.substring(SearchResult+1);
				document.getElementById(elementID).innerHTML=value;
				simplifying=true;
			}
			
			while(value.indexOf("+-")!=-1){
				SearchResult=value.indexOf("+-");
				value=value.substring(0,SearchResult)+value.substring(SearchResult+1);
				document.getElementById(elementID).innerHTML=value;
				simplifying=true;
			}
			
			while(value.indexOf("-+")!=-1){
				SearchResult=value.indexOf("-+");
				value=value.substring(0,SearchResult+1)+value.substring(SearchResult+2);
				document.getElementById(elementID).innerHTML=value;
				simplifying=true;
			}
			
			while(value.indexOf("--")!=-1){
				SearchResult=value.indexOf("--");
				value=value.substring(0,SearchResult)+"+"+value.substring(SearchResult+2);
				document.getElementById(elementID).innerHTML=value;
				simplifying=true;
			}
		}
	}
	//5. Έλεγχος υπόλοιπων συνδυασμών πράξεων (μόνο αν δεν έχει εμφανιστεί ήδη λάθος)
	if(DataOk){
		SearchResult=value.indexOf("+*");
		if(SearchResult!=-1) DataOk=false;
	}
	if(DataOk){
		SearchResult=value.indexOf("+/");
		if(SearchResult!=-1) DataOk=false;
	}	
	if(DataOk){
		SearchResult=value.indexOf("+%");
		if(SearchResult!=-1) DataOk=false;
	}
	if(DataOk){
		SearchResult=value.indexOf("-*");
		if(SearchResult!=-1) DataOk=false;
	}
	if(DataOk){
		SearchResult=value.indexOf("-/");
		if(SearchResult!=-1) DataOk=false;
	}
	if(DataOk){
		SearchResult=value.indexOf("-%");
		if(SearchResult!=-1) DataOk=false;
	}
	if(DataOk){
		SearchResult=value.indexOf("*+");
		if(SearchResult!=-1) DataOk=false;
	}
	if(DataOk){
		SearchResult=value.indexOf("*-");
		if(SearchResult!=-1) DataOk=false;
	}
	if(DataOk){
		SearchResult=value.indexOf("**");
		if(SearchResult!=-1) DataOk=false;
	}
	if(DataOk){
		SearchResult=value.indexOf("*/");
		if(SearchResult!=-1) DataOk=false;
	}
	if(DataOk){
		SearchResult=value.indexOf("*%");
		if(SearchResult!=-1) DataOk=false;
	}
	if(DataOk){
		SearchResult=value.indexOf("/+");
		if(SearchResult!=-1) DataOk=false;
	}
	if(DataOk){
		SearchResult=value.indexOf("/-");
		if(SearchResult!=-1) DataOk=false;
	}
	if(DataOk){
		SearchResult=value.indexOf("/*");
		if(SearchResult!=-1) DataOk=false;
	}
	if(DataOk){
		SearchResult=value.indexOf("//");
		if(SearchResult!=-1) DataOk=false;
	}
	if(DataOk){
		SearchResult=value.indexOf("/%");
		if(SearchResult!=-1) DataOk=false;
	}
	if (!DataOk) return DataOk; //Αν έχει ήδη βρεθεί σφάλμα, τερμάτισε τον έλεγχο

	//6. Έλεγχος ορθής αναφοράς αριθμού / μεταβλητής (μόνο αν δεν έχει εμφανιστεί ήδη λάθος)
	i=0;
	while(DataOk && i<Length){
		//6.1. Έλεγχος αριθμού
		if(value.charAt(i)>="0" && value.charAt(i)<="9" || value.charAt(i)=="."){
			var iStart=i;
			var decimalFound=false;
			//Έλεγχος συμβόλου πράξης πριν τον αριθμό
			if(iStart>0 && addOperators.indexOf(value.charAt(iStart-1))==-1 && multOperators.indexOf(value.charAt(iStart-1))==-1){
				DataOk=false;
			}
			while(i<Length && DataOk && value.charAt(i)>= "0" && value.charAt(i)<= "9" || value.charAt(i)=="." || value.charAt(i)=="%"){
		        if (value.charAt(i)=="."){
					if(!decimalFound){
			        	decimalFound=true;
			        }
			        else{
			        	DataOk=false;
			        }
		        }
				i++;
		    }
			//Έλεγχος συμβόλου πράξης μετά τον αριθμό
		    if(i<Length-1 && addOperators.indexOf(value.charAt(i))==-1 && multOperators.indexOf(value.charAt(i))==-1 && value.charAt(i)!=")"){
		        DataOk=false;
		    }
		}
		else if(value.charAt(i)==varName1.charAt(0)){
			//6.2. Έλεγχος μεταβλητής
			if(value.substring(i,i+varName1.length)==varName1){
				//Έλεγχος συμβόλου πράξης ή παρένθεσης που ανοίγει πριν τη μεταβλητή
				if(i>0 && addOperators.indexOf(value.charAt(i-1))==-1 && multOperators.indexOf(value.charAt(i-1))==-1 && value.charAt(i-1)!="("){
					DataOk=false;
				}
				i+=varName1.length;
				//Έλεγχος συμβόλου πράξης ή παρένθεσης που κλείνει μετά τη μεταβλητή
			    if(addOperators.indexOf(value.charAt(i))==-1 && multOperators.indexOf(value.charAt(i))==-1  && value.charAt(i)!=")"){
			        DataOk=false;
			    }
			}
			else{
				DataOk=false;
			}
		}
		else if(value.charAt(i)==varName2.charAt(0)){
			//6.2. Έλεγχος μεταβλητής
			if(value.substring(i,i+varName2.length)==varName2){
				//Έλεγχος συμβόλου πράξης ή παρένθεσης που ανοίγει πριν τη μεταβλητή
				if(i>0 && addOperators.indexOf(value.charAt(i-1))==-1 && multOperators.indexOf(value.charAt(i-1))==-1 && value.charAt(i-1)!="("){
					DataOk=false;
				}
				i+=varName2.length;
				//Έλεγχος συμβόλου πράξης ή παρένθεσης που κλείνει μετά τη μεταβλητή
			    if(addOperators.indexOf(value.charAt(i))==-1 && multOperators.indexOf(value.charAt(i))==-1  && value.charAt(i)!=")"){
			        DataOk=false;
			    }
			}
			else{
				DataOk=false;
			}
		}
		i++;
	}
	return DataOk;
}

function UserFunctionOutput(varName1,varName2,expression,varValue1,varValue2){
	//var EmptyExpressionErrMsg="Παρακαλώ δώστε μια αλγεβρική παράσταση";
	var ParenthesisErrMsg="Υπάρχει λάθος στην έκφραση που πληκτρολογήσατε. Παρακαλώ ελέγξτε τις παρενθέσεις.";
	//var ParenthesisErrResult="Αδυναμία εμφάνισης αποτελέσματος λόγω λανθασμένης εισαγωγής";
	var Length=expression.length,i;
	//var ErrorPos=0;
	var SubExpression="";
	var ExprValue=0;
	var LimitingSymbols="";
	LimitingSymbols = "+-";
	ExprValue=0;
	i=0;
	while(i<Length){
		switch(expression.charAt(i)){
		case "(":
			i++;
		    SubExpression="";
		    while(expression.charAt(i)!=")"){
		    	SubExpression=SubExpression+expression.charAt(i);
		        i++;
		    }
		    ExprValue=UserFunctionOutput(varName1,varName2,SubExpression,varValue1,varValue2);
		    i++;
		    break;
		case "s":
			if (expression.charAt(i + 1)=="i" && expression.charAt(i+2)=="n" && expression.charAt(i+3)=="("){
				i=i+4;
		        SubExpression="";
		        while(expression.charAt(i)!=")"){
		        	SubExpression=SubExpression+expression.charAt(i);
		        	i++;
		        }
		        ExprValue=Math.sin(UserFunctionOutput(varName1,varName2,SubExpression,varValue1,varValue2));
		        i++;
		    }
		    else{
		    	//σηματοδότησε σφάλμα
		    }
		    break;
		case "c":
			if (expression.charAt(i + 1)=="o" && expression.charAt(i+2)=="s" && expression.charAt(i+3)=="("){
				i=i+4;
				SubExpression="";
		        while(expression.charAt(i)!=")"){
		        	SubExpression=SubExpression+expression.charAt(i);
		            i++;
		        }
		        ExprValue=Math.cos(UserFunctionOutput(varName1,varName2,SubExpression,varValue1,varValue2));
		        i++;
		    }
		    else{
		    	//σηματοδότησε σφάλμα)
		    }
		    break;
		case "+":
			SubExpression="";
		    i++;
		    if(expression.charAt(i)=="("){
		    	do{
		    		SubExpression=SubExpression+expression.charAt(i);
		            i++;
		            if(i==Length){
		            	alert(ParenthesisErrMsg);
		            	return;
		            }
		        } while(expression.charAt(i)!=")");
		        SubExpression=SubExpression.substring(1);
		        i++;
		    }
		    else{
		    	do{
		    		SubExpression=SubExpression+expression.charAt(i);
		    		i++;
		    	}while (LimitingSymbols.indexOf(expression.charAt(i))==-1 && i<Length);
		    }
		    ExprValue=ExprValue+UserFunctionOutput(varName1,varName2,SubExpression,varValue1,varValue2);
		    break;
		case "-":
		    SubExpression="";
		    i++;
		    if(expression.charAt(i)=="("){
		    	do{
		    		SubExpression=SubExpression+expression.charAt(i);
		    		i++;
		    		if(i==Length){
		    			alert(ParenthesisErrMsg);
					    return;
				    }
		        } while (expression.charAt(i)!=")");
		        SubExpression=SubExpression.substring(1);
		        i++;
		    }
		    else{
		        do{
		          SubExpression=SubExpression+expression.charAt(i);
		          i++;
		        } while (LimitingSymbols.indexOf(expression.charAt(i))==-1 && i<Length);
		    }
		    ExprValue=ExprValue-UserFunctionOutput(varName1,varName2,SubExpression,varValue1,varValue2);
		    break;
		case "*":
			SubExpression="";
		    i++;
		    if (expression.charAt(i)=="("){
		    	do{
		    		SubExpression=SubExpression+expression.charAt(i);
		    		i++;
		    		if(i==Length){
		    			alert(ParenthesisErrMsg);
		    			return;
		    		};
		    	}while(expression.charAt(i)!=")");
		        SubExpression=SubExpression.substring(1);
		        i++;
		    }
		    else{
		    	do{
		    		SubExpression=SubExpression+expression.charAt(i);
		    		i++;
		        }while(LimitingSymbols.indexOf(expression.charAt(i))==-1 && i<Length);
		    }
		    ExprValue=ExprValue*UserFunctionOutput(varName1,varName2,SubExpression,varValue1,varValue2);
		    break;
		case "/":
			SubExpression="";
		    i++;
		    if(expression.charAt(i)=="("){
		    	do{
		    		SubExpression=SubExpression+expression.charAt(i);
		    		i++;
		    		if(i==Length){
		    			alert(ParenthesisErrMsg);
		    			return;
		    		}
		    	}while (expression.charAt(i)!=")");
		        SubExpression=SubExpression.substring(1);
		        i++;
		    }
		    else{
		    	  do{
		    		  SubExpression=SubExpression+expression.charAt(i);
				      i++;
				  }while(LimitingSymbols.indexOf(expression.charAt(i)) && i<Length);
		    }
		    ExprValue=ExprValue/UserFunctionOutput(varName1,varName2,SubExpression,varValue1,varValue2);
		    break;
		case varName1.charAt(0):
			ExprValue=varValue1;
		    i+=varName1.length;
		    break;
		case varName2.charAt(0):
			ExprValue=varValue2;
		    i+=varName2.length;
		    break;
		case "π":
		    ExprValue=Math.PI;
		    i++;
		    break;
		case "0":
		case "1":
		case "2":
		case "3":
		case "4":
		case "5":
		case "6":
		case "7":
		case "8":
		case "9":
		case ".":
			SubExpression="";
			while(i<Length && expression.charAt(i)>= "0" && expression.charAt(i)<= "9" || expression.charAt(i)=="." || expression.charAt(i)=="%"){
		        SubExpression=SubExpression+expression.charAt(i);
		        i++;
		    }
		    if(SubExpression.charAt(SubExpression.length-1)=="%"){
		        ExprValue=parseFloat(SubExpression)/100;
		    }
		    else{
		    	ExprValue=parseFloat(SubExpression);
		    }
		    break;
		  }
		}
	return ExprValue;
}
