/**
 * 
 */

var currentMatrix=[];
currentMatrix=[[1,2,3,4],
               [1,2,3,4],
               [1,2,3,4],
               [1,2,3,4],
               [1,2,3,4]
              ];

function presentExerciseMenu(){
	showExercises=true;
	initialiseHint();
	setVolatileHelp();
}

function presentSelectedExercise(exNo){
	var exNoToShow=exNo+1;
	selectedExercise=exNo;
	var question="";
	var thumbnailWidth=60;
	question+="<img src='img/return.png' class='actionButton' title='Επιστροφή στον κατάλογο των ασκήσεων' style='float: right;' onclick='initialiseHint()'>";
	//question+="<span class='exerciseTitle'>Δοκιμασία <img src='img/"+exNoToShow+".png' class='actionButton'></span>";
	question+="<img src='img/showSolution.png' class='actionButton' title='Εμφάνιση λύσης' style='float: right;' onclick='showSolution("+exNo+")'>";

	question+="<span class='exerciseTitle'>Δοκιμασία "+exNoToShow+"</span>";
	switch(currentPage){
	case pgImageCopy:
		var result=assembleExerciseText(exNo);
	    var rect=document.getElementById("showQuestion").getBoundingClientRect();
	    var questionWidth=rect.width-2*thumbnailWidth;

	    if(!result.thumbnails)thumbnailWidth=0;
	    	
		question+="<table><col width='"+thumbnailWidth+"'><col width='"+thumbnailWidth+"'><col width='"+questionWidth+"'>";
		question+="<tr>";
		if(result.thumbnails){
			question+="<td><img src='img/landscape10.png' style='padding:1px; border:1px solid #021a40;'></td>";
			question+="<td><img src='img/ex"+exNo+".png' style='padding:1px; border:1px solid #021a40;'></td>";
		}
		else{
			question+="<td></td>";
			question+="<td></td>";
		}
		question+="<td>"+result.text+"</td>";
		question+="</tr></table>";
		question+="</p>"+result.additional;
		break;
	case pgSortedShow:
		stopCode();
		$("#runTool").show(jQueryAnimationRate);
		$("#btnPlay").show();
		$("#btnPause").hide();
		
		question+="<p>Συμπλήρωσε το απόσπασμα κώδικα στα αριστερά ώστε οι αριθμητικές τιμές του πίνακα <b>timh</b> να εμφανιστούν κατά αύξουσα σειρά.</p>";
		populateMatrix();
		break;
	}
	//question+="<img src='img/showSolution.png' class='actionButton' title='Εμφάνιση λύσης' onclick='showSolution("+exNo+")'>";
	if(currentPage==pgImageCopy && exNo==13)question+="<span id='rotationsLink'> Θα βρεις περισσότερες πληροφορίες για τους αλγόριθμους περιστροφής <a href='https://en.wikipedia.org/wiki/Rotation_matrix' target='_blank'>εδώ</a>.</span>";
	document.getElementById("showQuestion").innerHTML=question;
	$("#rotationsLink").hide();
}

function assembleExerciseText(exNo){
	var showThumbnails=true;
	var question="<p>Γράψε πρόγραμμα ώστε ";
	var additionalText="";
	switch(exNo){
	case 0:
		showThumbnails=false;
		question+="η αντιγραφή της εικόνας να γίνεται κατά γραμμή και όχι κατά στήλη.";
		break;
	case 1:
		question+="να εμφανιστεί το πάνω μισό της εικόνας.";
		break;
	case 2:
		question+="να εμφανιστεί το δεξί μισό της εικόνας.";
		break;
	case 3:
		question+="να εμφανιστεί το κατά πλάτος μεσαίο 1/3 της εικόνας.";
		break;
	case 4:
		question+="να εμφανιστεί η συμμετρική της εικόνας ως προς οριζόντιο άξονα συμμετρίας (υπάρχουν τουλάχιστον δύο παραλλαγές λύσης).";
		break;
	case 5:
		question+="να εμφανιστεί η συμμετρική της εικόνας ως προς κατακόρυφο άξονα συμμετρίας (υπάρχουν τουλάχιστον δύο παραλλαγές λύσης).";
		break;
	case 6:
		question+="η εικόνα να σμικρυνθεί στο 25% του αρχικού εμβαδού της (δηλ. το μήκος και το πλάτος της να μειωθούν στο μισό).";
		break;
	case 7:
		question+="η εικόνα να σμικρυνθεί στο 25% του αρχικού εμβαδού της (δηλ. το μήκος και το πλάτος της να μειωθούν στο μισό) και να εμφανιστεί στην κάτω δεξιά γωνία του πλαισίου picture2.";
		break;
	case 8:
		question+="η εικόνα να εμφανιστεί στραμμένη κατά 90° με φορά ίδια εκείνης των δεικτών του ρολογιού.";
		break;
	case 9:
		question+="να εμφανιστεί το τμήμα της εικόνας που βρίσκεται μέσα σε ορθογώνιο ισοσκελές τρίγωνο, του οποίου η ορθή γωνία συμπίπτει με την κάτω αριστερή γωνία της εικόνας και το μήκος των ίσων σκελών ισούται με το ύψος της εικόνας.";
		break;
	case 10:
		question+="να εμφανιστεί το πάνω μισό της εικόνας και η βάση του να έχει κυματοειδή μορφή.";
		break;
	case 11:
		question+="να εμφανιστεί το τμήμα της εικόνας που βρίσκεται <b>πάνω</b> από την <i>κύρια διαγώνιο</i> του ορθογωνίου παραλληλεπιπέδου.</p>";
		additionalText="<p>ΥΠΟΔΕΙΞΗ: <i>Κύρια</i> ονομάζεται η διαγώνιος που ξεκινά από την <b>πάνω αριστερή</b> γωνία και φτάνει στην <b>κάτω δεξιά</b>.</p>";
		additionalText+="<p>ΥΠΕΝΘΥΜΙΣΗ: Στις οθόνες των Η/Υ η αρχή του συστήματος αναφοράς βρίσκεται στην <b>πάνω</b> αριστερή γωνία της εικόνας, δηλ. οι συντεταγμενες του άξονα y αυξάνονται προς τα <b>κάτω</b>.</p>";
		break;
	case 12:
		question+="να εμφανιστεί το τμήμα της εικόνας που βρίσκεται <b>κάτω</b> από τη <i>δευτερεύουσα διαγώνιο</i> του ορθογωνίου παραλληλεπιπέδου που την περικλείει.</p>";
		additionalText="<p>ΥΠΟΔΕΙΞΗ: <i>Δευτερεύουσα</i> ονομάζεται η διαγώνιος που ξεκινά από την <b>κάτω αριστερή</b> γωνία και φτάνει στην <b>πάνω δεξιά</b>.</p>";
		additionalText+="<p>ΥΠΕΝΘΥΜΙΣΗ: Στις οθόνες των Η/Υ η αρχή του συστήματος αναφοράς βρίσκεται στην <b>πάνω</b> αριστερή γωνία της εικόνας, δηλ. οι συντεταγμενες του άξονα y αυξάνονται προς τα <b>κάτω</b>.</p>";
		break;
	case 13:
		question+="η εικόνα να εμφανιστεί στραμμένη κατά 90° με φορά αντίθετη εκείνης των δεικτών του ρολογιού.</p>";
		break;
	}
    return {
        text: question,
        additional: additionalText,
        thumbnails: showThumbnails
    };
}

function populateMatrix(){
	switch(selectedExercise){
	case 0:
		drawMatrix(0,0,noOfRows-1,1,0,noOfColumns-1,1);
		break;
	case 1:
		drawMatrix(0,noOfRows-1,0,-1,0,noOfColumns-1,1);
		break;
	case 2:
		drawMatrix(0,noOfRows-1,0,-1,noOfColumns-1,0,-1);
		break;
	case 3:
		drawMatrix(0,0,noOfRows-1,1,noOfColumns-1,0,-1);
		break;
	case 4:
		drawMatrix(1,0,noOfRows-1,1,0,noOfColumns-1,1);
		break;
	case 5:
		drawMatrix(1,noOfRows-1,0,-1,0,noOfColumns-1,1);
		break;
	case 6:
		drawMatrix(1,noOfRows-1,0,-1,noOfColumns-1,0,-1);
		break;
	case 7:
		drawMatrix(1,0,noOfRows-1,1,noOfColumns-1,0,-1);
		break;
	}
	
}

function drawMatrix(variationSelector,iStart,iEnd,iStep,jStart,jEnd,jStep){
	var i=0,iIndex=0;
	var j=0,jIndex=0;
	var valToShow=1;
	var metrics;
	cntx.fillStyle="white";
	cntx.fillRect(0,0,canvas.width,canvas.height);
	cntx.font="11px Arial";
	cntx.beginPath();
	cntx.fillStyle="black";
	cntx.strokeStyle="black";
	for(j=0;j<=noOfColumns;j++){
		//Εμφάνιση Α/Α στήλης
		jIndex=j+1;
		metrics=cntx.measureText(jIndex+"");
		if(j<noOfColumns)cntx.fillText(jIndex,matrixBorder+j*cellWidth+(cellWidth-metrics.width)/2,matrixBorder-bottomBorder);
		//Σχεδίαση στήλης
		cntx.moveTo(matrixBorder+j*cellWidth,matrixBorder);
		cntx.lineTo(matrixBorder+j*cellWidth,matrixBorder+noOfRows*cellHeight);
	}
	for(i=0;i<=noOfRows;i++){
		//Εμφάνιση Α/Α γραμμής
		iIndex=i+1;
		metrics=cntx.measureText(iIndex+" ");
		if(i<noOfRows)cntx.fillText(iIndex,matrixBorder-metrics.width,matrixBorder+iIndex*cellHeight-bottomBorder);
		//Σχεδίαση γραμμής
		cntx.moveTo(matrixBorder,matrixBorder+i*cellHeight);
		cntx.lineTo(matrixBorder+noOfColumns*cellWidth,matrixBorder+i*cellHeight);
	}
	cntx.stroke();
	cntx.font="15px Georgia";
	cntx.fillStyle="blue";
	
	if(variationSelector==0){
		i=iStart;
		while(i<=iEnd && iStep>0 || i>=iEnd && iStep<0){
			j=jStart;
			while(j<=jEnd && jStep>0 || j>=jEnd && jStep<0){
				currentMatrix[i][j]=valToShow;
				metrics=cntx.measureText(valToShow+"");
				cntx.fillText(valToShow,matrixBorder+j*cellWidth+(cellWidth-metrics.width)/2,matrixBorder+(i+1)*cellHeight-3*bottomBorder);
				valToShow++;
				j+=jStep;
			}
			i+=iStep;
		}
	}
	else{
		j=jStart;
		while(j<=jEnd && jStep>0 || j>=jEnd && jStep<0){
			i=iStart;
			while(i<=iEnd && iStep>0 || i>=iEnd && iStep<0){
				currentMatrix[i][j]=valToShow;
				metrics=cntx.measureText(valToShow+"");
				cntx.fillText(valToShow,matrixBorder+j*cellWidth+(cellWidth-metrics.width)/2,matrixBorder+(i+1)*cellHeight-3*bottomBorder);
				valToShow++;
				i+=iStep;
			}
			j+=jStep;
		}
	}
}

function showSolution(exNo){
	switch(currentPage){
	case pgImageCopy:
		showImageSolution(exNo);
		break;
	case pgSortedShow:
		showMatrixSolution(exNo);
	}
}

function showImageSolution(exNo){
	var solVar1="";
	var solStartVal1="";
	var solEndVal1="";
	var solStep1="";
	var solCoord1="";
	var solVar2="";
	var solStartVal2="";
	var solEndVal2="";
	var solStep2="";
	var solCoord2="";
	switch(exNo){
	case 0:
		solVar1="y";
		solStartVal1="0";
		solEndVal1=""+(imgHeight-1);
		solStep1="1";
		solCoord1="x";
		solVar2="x";
		solStartVal2="0";
		solEndVal2=""+(imgWidth-1);
		solStep2="1";
		solCoord2="y";
		break;			
	case 1:
		solVar1="x";
		solStartVal1="0";
		solEndVal1=""+(imgWidth-1);
		solStep1="1";
		solCoord1="x";
		solVar2="y";
		solStartVal2="0";
		solEndVal2=imgHeight+"/2";
		solStep2="1";
		solCoord2="y";
		break;			
	case 2:
		solVar1="x";
		solStartVal1=imgWidth+"/2";
		solEndVal1=""+(imgWidth);
		solStep1="1";
		solCoord1="x";
		solVar2="y";
		solStartVal2="0";
		solEndVal2=""+(imgHeight);
		solStep2="1";
		solCoord2="y";
		break;			
	case 3:
		solVar1="x";
		solStartVal1=""+imgWidth+"/3";
		solEndVal1="2*"+imgWidth+"/3";
		solStep1="1";
		solCoord1="x";
		solVar2="y";
		solStartVal2="0";
		solEndVal2=""+(imgHeight-1);
		solStep2="1";
		solCoord2="y";
		break;			
	case 4:
		solVar1="x";
		solStartVal1="0";
		solEndVal1=""+(imgWidth-1);
		solStep1="1";
		solCoord1="x";
		solVar2="y";
		solStartVal2="0";
		solEndVal2=""+(imgHeight-1);
		solStep2="1";
		solCoord2=(imgHeight-1)+"-y";
		break;			
	case 5:
		solVar1="x";
		solStartVal1="0";
		solEndVal1=""+(imgWidth-1);
		solStep1="1";
		solCoord1=(imgWidth-1)+"-x";
		solVar2="y";
		solStartVal2="0";
		solEndVal2=""+(imgHeight-1);
		solStep2="1";
		solCoord2="y";
		break;			
	case 6:
		solVar1="x";
		solStartVal1="0";
		solEndVal1=""+(imgWidth-1);
		solStep1="2";
		solCoord1="x/2";
		solVar2="y";
		solStartVal2="0";
		solEndVal2=""+(imgHeight-1);
		solStep2="2";
		solCoord2="y/2";
		break;			
	case 7:
		solVar1="x";
		solStartVal1="0";
		solEndVal1=""+(imgWidth-1);
		solStep1="2";
		solCoord1=imgWidth+"/2+x/2";
		solVar2="y";
		solStartVal2="0";
		solEndVal2=""+(imgHeight-1);
		solStep2="2";
		solCoord2=imgHeight+"/2+y/2";
		break;			
	case 8:
		solVar1="x";
		solStartVal1="0";
		solEndVal1=""+(imgHeight-1);
		solStep1="1";
		solCoord1=(imgHeight-1)+"-y";
		solVar2="y";
		solStartVal2="0";
		solEndVal2=""+(imgHeight-1);
		solStep2="1";
		solCoord2="x";
		break;			
	case 9:
		solVar1="x";
		solStartVal1="0";
		solEndVal1=""+(imgWidth-1);
		solStep1="1";
		solCoord1="x";
		solVar2="y";
		solStartVal2="x";
		solEndVal2=""+(imgHeight-1);
		solStep2="1";
		solCoord2="y";
		break;			
	case 10:
		solVar1="x";
		solStartVal1="0";
		solEndVal1=""+(imgWidth-1);
		solStep1="1";
		solCoord1="x";
		solVar2="y";
		solStartVal2="0";
		solEndVal2=imgHeight+"/2+5*sin(π*x/20)";
		solStep2="1";
		solCoord2="y";
		break;			
	case 11:
		solVar1="x";
		solStartVal1="0";
		solEndVal1=""+(imgWidth-1);
		solStep1="1";
		solCoord1="x";
		solVar2="y";
		solStartVal2="0";
		solEndVal2="x*"+imgHeight+"/"+(imgWidth-1);
		solStep2="1";
		solCoord2="y";
		break;			
	case 12:
		solVar1="x";
		solStartVal1="0";
		solEndVal1=""+(imgWidth-1);
		solStep1="1";
		solCoord1="x";
		solVar2="y";
		solStartVal2="-"+(imgHeight-1)+"*x/"+imgWidth+"+"+(imgHeight-1);
		solEndVal2=""+(imgHeight-1);
		solStep2="1";
		solCoord2="y";
		break;			
	case 13:
		solVar1="x";
		solStartVal1="0";
		solEndVal1=""+(imgHeight-1);
		solStep1="1";
		solCoord1="y";
		solVar2="y";
		solStartVal2="0";
		solEndVal2=""+(imgHeight-1);
		solStep2="1";
		solCoord2=(imgHeight-1)+"-x";
		$("#rotationsLink").show(jQueryAnimationRate);
		break;			
	}
	stopCode();
	prepareImageCopy();
	document.getElementById("var1").innerHTML=solVar1;
	document.getElementById("startVal1").innerHTML=solStartVal1;
	document.getElementById("endVal1").innerHTML=solEndVal1;
	document.getElementById("stepVal1").innerHTML=solStep1;
	document.getElementById("coord1").innerHTML=solCoord1;
	document.getElementById("var2").innerHTML=solVar2;
	document.getElementById("startVal2").innerHTML=solStartVal2;
	document.getElementById("endVal2").innerHTML=solEndVal2;
	document.getElementById("stepVal2").innerHTML=solStep2;
	document.getElementById("coord2").innerHTML=solCoord2;
}

function showMatrixSolution(exNo){
	var solVar1="";
	var solStartVal1="";
	var solEndVal1="";
	var solStep1="";
	var solVar2="";
	var solStartVal2="";
	var solEndVal2="";
	var solStep2="";
	switch(exNo){
	case 0:
		solVar1="i";
		solStartVal1="1";
		solEndVal1=""+noOfRows;
		solStep1="1";
		solVar2="j";
		solStartVal2="1";
		solEndVal2=""+noOfColumns;
		solStep2="1";
		break;
	case 1:
		solVar1="i";
		solStartVal1=""+noOfRows;
		solEndVal1="1";
		solStep1="-1";
		solVar2="j";
		solStartVal2="1";
		solEndVal2=""+noOfColumns;
		solStep2="1";
		break;
	case 2:
		solVar1="i";
		solStartVal1=""+noOfRows;
		solEndVal1="1";
		solStep1="-1";
		solVar2="j";
		solStartVal2=""+noOfColumns;
		solEndVal2="1";
		solStep2="-1";
		break;
	case 3:
		solVar1="i";
		solStartVal1="1";
		solEndVal1=""+noOfRows;
		solStep1="1";
		solVar2="j";
		solStartVal2=""+noOfColumns;
		solEndVal2="1";
		solStep2="-1";
		break;
	case 4:
		solVar1="j";
		solStartVal1="1";
		solEndVal1=""+noOfColumns;
		solStep1="1";
		solVar2="i";
		solStartVal2="1";
		solEndVal2=""+noOfRows;
		solStep2="1";
		break;
	case 5:
		solVar1="j";
		solStartVal1="1";
		solEndVal1=""+noOfColumns;
		solStep1="1";
		solVar2="i";
		solStartVal2=""+noOfRows;
		solEndVal2="1";
		solStep2="-1";
		break;
	case 6:
		solVar1="j";
		solStartVal1=""+noOfColumns;
		solEndVal1="1";
		solStep1="-1";
		solVar2="i";
		solStartVal2=""+noOfRows;
		solEndVal2="1";
		solStep2="-1";
		break;
	case 7:
		solVar1="j";
		solStartVal1=""+noOfColumns;
		solEndVal1="1";
		solStep1="-1";
		solVar2="i";
		solStartVal2="1";
		solEndVal2=""+noOfRows;
		solStep2="1";
		break;
	}
    stopCode();
    $("#runTool").show(jQueryAnimationRate);
    $("#btnPlay").show();
    $("#btnPause").hide();
    
    document.getElementById("var1").innerHTML=solVar1;
	document.getElementById("startVal1").innerHTML=solStartVal1;
	document.getElementById("endVal1").innerHTML=solEndVal1;
	document.getElementById("stepVal1").innerHTML=solStep1;
	document.getElementById("var2").innerHTML=solVar2;
	document.getElementById("startVal2").innerHTML=solStartVal2;
	document.getElementById("endVal2").innerHTML=solEndVal2;
	document.getElementById("stepVal2").innerHTML=solStep2;
	populateMatrix();
} 